<template>
	<div class="sidemenu" :class="[props.toggle ? 'hidden' : '']">
		<n-menu :options="menuOptions" />
	</div>
</template>

<script setup>
import { NMenu } from "naive-ui/es";
import { useRouter, RouterLink } from "vue-router";
import { find, get, map } from "lodash-es";
import { computed } from "@vue/reactivity";
import { h } from "vue";

const router = useRouter();
const props = defineProps(["toggle"]);

const menuOptions = computed(() => {
	const routes = get(router, "options.routes", []);
	if (routes.length) {
		const layoutRoute = find(routes, { name: "Layout" });
		const mainRoutes = get(layoutRoute, "children", []);
		return map(mainRoutes, (r) => generateMenuItems(r));
	}
	return [];
});

const generateMenuItemsLabel = (route) => {
	if (route.children) {
		return route.meta.title;
	}
	return h(
		RouterLink,
		{
			to: {
				name: route.name,
			},
		},
		{ default: () => route.meta.title }
	);
};

const generateMenuItems = (route) => {
	return {
		label: () => generateMenuItemsLabel(route),
		key: route.path,
		children: route.children
			? map(route.children, (r) => generateMenuItems(r))
			: null,
	};
};
</script>

<style>
.sidemenu {
	@apply w-[260px] h-full border-r border-gray-400 bg-[#F7F8FC];
	@apply relative flex flex-col z-2;
	@apply overflow-x-hidden transition-all ease-in-out duration-300;
}

.sidemenu.hidden {
	display: none;
}

.menus::-webkit-scrollbar {
	@apply hidden;
}

.menus {
	@apply flex flex-col flex-1 h-full py-[20px] px-[8px];
	@apply overflow-x-hidden overflow-y-auto;
}

.settings {
	@apply w-full h-[50px];
	background: lightgreen;
}
</style>
